/**
 * Copyright (c) 2020-2022 Hailo Technologies Ltd. All rights reserved.
 * Distributed under the MIT license (https://opensource.org/licenses/MIT)
 **/
/**
 * @file hailort.hpp
 * @brief C++ API for HailoRT library.
 *
 * C++ API for Hailo runtime (HailoRT) library for neural network inference on Hailo devices.
 **/

#ifndef _HAILORT_HPP_
#define _HAILORT_HPP_

#include "hailo/hailort.h"
#include "hailo/hailort_common.hpp"
#include "hailo/hef.hpp"
#include "hailo/device.hpp"
#include "hailo/vdevice.hpp"
#include "hailo/network_group.hpp"
#include "hailo/stream.hpp"
#include "hailo/vstream.hpp"
#include "hailo/inference_pipeline.hpp"
#include "hailo/infer_model.hpp"
#include "hailo/transform.hpp"
#include "hailo/expected.hpp"
#include "hailo/buffer.hpp"
#include "hailo/event.hpp"
#include "hailo/runtime_statistics.hpp"
#include "hailo/network_rate_calculator.hpp"
#include "hailo/quantization.hpp"
#include "hailo/hailort_defaults.hpp"
#include "hailo/dma_mapped_buffer.hpp"

#endif /* _HAILORT_HPP_ */
